// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"encoding/json"
	"github.com/oracle/oci-go-sdk/v45/common"
)

// HostScanAgentConfiguration Agent configuration for host scan agent settings. This model is polymorphic, presenting different configuration options based on selected agent vendor.
type HostScanAgentConfiguration interface {
}

type hostscanagentconfiguration struct {
	JsonData []byte
	Vendor   string `json:"vendor"`
}

// UnmarshalJSON unmarshals json
func (m *hostscanagentconfiguration) UnmarshalJSON(data []byte) error {
	m.JsonData = data
	type Unmarshalerhostscanagentconfiguration hostscanagentconfiguration
	s := struct {
		Model Unmarshalerhostscanagentconfiguration
	}{}
	err := json.Unmarshal(data, &s.Model)
	if err != nil {
		return err
	}
	m.Vendor = s.Model.Vendor

	return err
}

// UnmarshalPolymorphicJSON unmarshals polymorphic json
func (m *hostscanagentconfiguration) UnmarshalPolymorphicJSON(data []byte) (interface{}, error) {

	if data == nil || string(data) == "null" {
		return nil, nil
	}

	var err error
	switch m.Vendor {
	case "OCI":
		mm := HostScanAgentConfigurationOci{}
		err = json.Unmarshal(data, &mm)
		return mm, err
	default:
		return *m, nil
	}
}

func (m hostscanagentconfiguration) String() string {
	return common.PointerString(m)
}

// HostScanAgentConfigurationVendorEnum Enum with underlying type: string
type HostScanAgentConfigurationVendorEnum string

// Set of constants representing the allowable values for HostScanAgentConfigurationVendorEnum
const (
	HostScanAgentConfigurationVendorOci HostScanAgentConfigurationVendorEnum = "OCI"
)

var mappingHostScanAgentConfigurationVendor = map[string]HostScanAgentConfigurationVendorEnum{
	"OCI": HostScanAgentConfigurationVendorOci,
}

// GetHostScanAgentConfigurationVendorEnumValues Enumerates the set of values for HostScanAgentConfigurationVendorEnum
func GetHostScanAgentConfigurationVendorEnumValues() []HostScanAgentConfigurationVendorEnum {
	values := make([]HostScanAgentConfigurationVendorEnum, 0)
	for _, v := range mappingHostScanAgentConfigurationVendor {
		values = append(values, v)
	}
	return values
}
