// Copyright (c) 2016, 2018, 2021, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v45/common"
)

// HostVulnerabilityImpactedHostSummary Information on a host impacted by a vulnerability
type HostVulnerabilityImpactedHostSummary struct {

	// The compute instance ID of the impacted host
	InstanceId *string `mandatory:"true" json:"instanceId"`

	// The compartment ID of the impacted host
	CompartmentId *string `mandatory:"true" json:"compartmentId"`

	// The ID of the last host agent scan result
	LastAgentScanId *string `mandatory:"true" json:"lastAgentScanId"`

	// The current state of the resource.
	LifecycleState LifecycleStateEnum `mandatory:"false" json:"lifecycleState,omitempty"`
}

func (m HostVulnerabilityImpactedHostSummary) String() string {
	return common.PointerString(m)
}
